;[]------------------------------------------------------------------------[]
;|                                                                          |
;| KEYS.INC                                                                 |
;|                                                                          |
;| This file supplies you with some standard key-values for use with the    |
;| GETKEY macro                                                             |
;|                                                                          |
;[]------------------------------------------------------------------------[]


BackSpace      equ	8
Return         equ	13
Escape         equ	27
Tab            equ	9
Space	       equ	32
Cursor_Up      equ	328
Cursor_Down    equ	336
Cursor_Left    equ	331
Cursor_Right   equ	333
Cursor_Home    equ	327
Cursor_End     equ	335
Cursor_Pgup    equ	329
Cursor_Pgdwn   equ	337
Insert         equ	338
Delete         equ	339
Ctrl_Left      equ	371
Ctrl_Right     equ	372
F1_Key         equ	315
F2_Key         equ	316
F3_Key         equ	317
F4_Key         equ	318
F5_Key         equ	319
F6_Key         equ	320
F7_Key         equ	321
F8_Key         equ	322
F9_Key         equ	323
F10_Key        equ	324



GETKEY MACRO
	LOCAL NoExtKey,EndKey,NoKey
	xor ax,ax
        mov ah,1
        int 16h
        jz short NoKey
        xor ax,ax
        int 16h
        test al,al
        jnz short NoExtKey
        movzx ax,ah
        add ax,256
        jmp short EndKey
 NoKey:
 	xor ax,ax
 NoExtKey:
 	xor ah,ah
 EndKey:
	ENDM


