/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                   (c) 1993,1994 by Kaya Memisoglu                       */
/*                                    aka Marc van Shaney                  */
/*                                                                         */
/* Die kommerzielle Nutzung des Source-Codes ohne meine schriftliche       */
/* Genehmigung ist untersagt. Desweiteren hafte ich fr keinerlei          */
/* Schaden den das Programm verursacht.                                    */
/*                                                                         */
/* Geschrieben mit Borland C++ 3.1                                         */
/*     Borland C++ ist eingetragenes Warenzeichen der                      */
/*                                  Borland Inernational INC               */
/*                                                                         */
/*                                                                         */
/* 18.1.1994 - Kaya Memisoglu                                              */
/*                                                                         */
/***************************************************************************/


#ifndef __EXT386_H
#define __EXT386_H

#ifndef NULL
 #define NULL                          0
#endif

#ifndef _SIZE_T
 #define _SIZE_T
 typedef unsigned size_t;
#endif


#ifndef _SIZE_L
 #define _SIZE_L
 typedef unsigned long size_l;
#endif


#ifndef _L_PTR
 #define _L_PTR
 typedef unsigned long l_ptr;
#endif

#ifndef TRUE
 #define TRUE                	1
 #define FALSE               	-1
 #define WRONG_TOKEN         	-10
 #define CONTINUE            	2
 #define FAIL                	-11
 #define ASK_ALWAYS          	3
 #define Success 		0
#endif

#define EXT_ALREADY_V86		-4
#define EXT_NO_HIMEM		-5
#define EXT_NO_386		-6
#define EXT_NO_XMS		-7
#define EXT_HIMEM_PROBLEM	-8
#define EXT_NO_DPMI		-9
#define EXT_NO_RAM		-10
#define EXT_NO_DPMI32		-11
#define EXT_MODIFIED		-12

#define EXT_EXIT_ON_LOWMEM	1L
#define EXT_DISPLAY_INFO	2L
#define EXT_USE_UMB		4L
#define EXT_EXIT_ON_RESET	8L
#define EXT_VERBOSE_RESET	16L
#define EXT_VERBOSE_PAUSE	32L

#ifndef PTR2LONG
#define PTR2LONG(a) (unsigned long)(((unsigned long)a & 0x0ffff0000L) >>12)+((unsigned long)a & 0x0ffffL)
#endif

extern void far *Malloc    (size_l);
extern int       Free      (void far *);
extern size_l    Coreleft  (void);
extern void far *DMA_Malloc(size_l);

extern int Init_EXT386(size_t io_buf_size,unsigned long flags);
extern int Exit_EXT386(void);

extern int Creat(char *fname,int attrib);
extern int Open (char *fname,int mode);
extern int Close(int handle);
extern int Write(int handle,l_ptr src ,size_l len);
extern int Read (int handle,l_ptr dest,size_l len);
extern int Seek (int handle,size_l pos,int mode);
extern int Tell (int handle);

extern l_ptr  EXT_alloc   (size_l size);
extern int    EXT_free    (l_ptr address);
extern size_l EXT_coreleft(void);

extern l_ptr Memcpy(l_ptr dest,l_ptr src ,size_l len);
extern int   Memcmp(l_ptr dest,l_ptr src ,size_l len);
extern l_ptr Memset(l_ptr dest,char c    ,size_l len);
extern l_ptr Memchr(l_ptr dest,char c    ,size_l len);

#endif